Package | Class | Tree | Deprecated
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb
Class jdbcDatabaseMetaData

    java.lang.Object
      |
      +--org.hsqldb.jdbcDatabaseMetaData

public class jdbcDatabaseMetaData
extends java.lang.Object
implements java.sql.DatabaseMetaData

Comprehensive information about the database as a whole.

Many of the methods here return lists of information in the form of `ResultSet` objects. You can use the normal ResultSet methods such as getString and getInt to retrieve the data from these ResultSets. If a given form of metadata is not available, these methods should throw an SQLException.

Some of these methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to a null ref, that argument's criteria will be dropped from the search.

An `SQLException` will be thrown if a driver does not support a meta data method. In the case of methods that return a ResultSet, either a ResultSet (which may be empty) is returned or a SQLException is thrown.

Fields inherited from interface java.sql.DatabaseMetaData
`bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

Constructor Summary
`(package private)` | `jdbcDatabaseMetaData(jdbcConnection c)` Constructor declaration

Method Summary
`boolean` | `allProceduresAreCallable()` Can all the procedures returned by getProcedures be called by the current user?
`boolean` | `allTablesAreSelectable()` Can all the tables returned by getTable be SELECTed by the current user?
`boolean` | `dataDefinitionCausesTransactionCommit()` Does a data definition statement within a transaction force the transaction to commit?
`boolean` | `dataDefinitionIgnoredInTransactions()` Is a data definition statement within a transaction ignored?
`boolean` | `deletesAreDetected(int type)` JDBC 2.0 Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted().
`boolean` | `doesMaxRowSizeIncludeBlobs()` Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
`java.sql.ResultSet` | `getBestRowIdentifier(java.lang.String catalog, java.lang.String schema, java.lang.String table, int scope, boolean nullable)` Gets a description of a table's optimal set of columns that uniquely identifies a row.
`java.sql.ResultSet` | `getCatalogs()` Gets the catalog names available in this database.
`java.lang.String` | `getCatalogSeparator()` What's the separator between catalog and table name?
`java.lang.String` | `getCatalogTerm()` What's the database vendor's preferred term for "catalog"?
`java.sql.ResultSet` | `getColumnPrivileges(java.lang.String catalog, java.lang.String schema, java.lang.String tableP, java.lang.String columnNamePattern)` Gets a description of the access rights for a table's columns.
`java.sql.ResultSet` | `getColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String columnNamePattern)` Gets a description of table columns available in the specified catalog.
`java.sql.Connection` | `getConnection()` JDBC 2.0 Retrieves the connection that produced this metadata object.
`java.sql.ResultSet` | `getCrossReference(java.lang.String primaryCatalog, java.lang.String primarySchema, java.lang.String primaryTable, java.lang.String foreignCatalog, java.lang.String foreignSchema, java.lang.String foreignTable)` Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.
`java.lang.String` | `getDatabaseProductName()` What's the name of this database product?
`java.lang.String` | `getDatabaseProductVersion()` What's the version of this database product?
`int` | `getDefaultTransactionIsolation()` What's the database's default transaction isolation level? The values are defined in `java.sql.Connection`.
`int` | `getDriverMajorVersion()` What's this JDBC driver's major version number?
`int` | `getDriverMinorVersion()` What's this JDBC driver's minor version number?
`java.lang.String` | `getDriverName()` What's the name of this JDBC driver?
`java.lang.String` | `getDriverVersion()` What's the version of this JDBC driver?
`java.sql.ResultSet` | `getExportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Gets a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
`java.lang.String` | `getExtraNameCharacters()` Gets all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
`java.lang.String` | `getIdentifierQuoteString()` What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported.
`java.sql.ResultSet` | `getImportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Gets a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
`java.sql.ResultSet` | `getIndexInfo(java.lang.String catalog, java.lang.String schema, java.lang.String tableP, boolean unique, boolean approximate)` Gets a description of a table's indices and statistics.
`int` | `getMaxBinaryLiteralLength()` How many hex characters can you have in an inline binary literal?
`int` | `getMaxCatalogNameLength()` What's the maximum length of a catalog name?
`int` | `getMaxCharLiteralLength()` What's the max length for a character literal?
`int` | `getMaxColumnNameLength()` What's the limit on column name length?
`int` | `getMaxColumnsInGroupBy()` What's the maximum number of columns in a "GROUP BY" clause?
`int` | `getMaxColumnsInIndex()` What's the maximum number of columns allowed in an index?
`int` | `getMaxColumnsInOrderBy()` What's the maximum number of columns in an "ORDER BY" clause?
`int` | `getMaxColumnsInSelect()` What's the maximum number of columns in a "SELECT" list?
`int` | `getMaxColumnsInTable()` What's the maximum number of columns in a table?
`int` | `getMaxConnections()` How many active connections can we have at a time to this database?
`int` | `getMaxCursorNameLength()` What's the maximum cursor name length?
`int` | `getMaxIndexLength()` What's the maximum length of an index (in bytes)?
`int` | `getMaxProcedureNameLength()` What's the maximum length of a procedure name?
`int` | `getMaxRowSize()` What's the maximum length of a single row?
`int` | `getMaxSchemaNameLength()` What's the maximum length allowed for a schema name?
`int` | `getMaxStatementLength()` What's the maximum length of a SQL statement?
`int` | `getMaxStatements()` How many active statements can we have open at one time to this database?
`int` | `getMaxTableNameLength()` What's the maximum length of a table name?
`int` | `getMaxTablesInSelect()` What's the maximum number of tables in a SELECT statement?
`int` | `getMaxUserNameLength()` What's the maximum length of a user name?
`java.lang.String` | `getNumericFunctions()` Gets a comma-separated list of math functions.
`java.sql.ResultSet` | `getPrimaryKeys(java.lang.String catalog, java.lang.String schema, java.lang.String tableP)` Gets a description of a table's primary key columns.
`java.sql.ResultSet` | `getProcedureColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern, java.lang.String columnNamePattern)` Gets a description of a catalog's stored procedure parameters and result columns.
`java.sql.ResultSet` | `getProcedures(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern)` Gets a description of the stored procedures available in a catalog.
`java.lang.String` | `getProcedureTerm()` What's the database vendor's preferred term for "procedure"?
`java.sql.ResultSet` | `getSchemas()` Gets the schema names available in this database.
`java.lang.String` | `getSchemaTerm()` What's the database vendor's preferred term for "schema"?
`java.lang.String` | `getSearchStringEscape()` Gets the string that can be used to escape wildcard characters.
`java.lang.String` | `getSQLKeywords()` Gets a comma-separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
`java.lang.String` | `getStringFunctions()` Gets a comma-separated list of string functions.
`java.lang.String` | `getSystemFunctions()` Gets a comma-separated list of system functions.
`java.sql.ResultSet` | `getTablePrivileges(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern)` Gets a description of the access rights for each table available in a catalog.
`java.sql.ResultSet` | `getTables(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String[] types)` Gets a description of tables available in a catalog.
`java.sql.ResultSet` | `getTableTypes()` Gets the table types available in this database.
`java.lang.String` | `getTimeDateFunctions()` Gets a comma-separated list of time and date functions.
`java.sql.ResultSet` | `getTypeInfo()` Gets a description of all the standard SQL types supported by this database.
`java.sql.ResultSet` | `getUDTs(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern, int[] types)` JDBC 2.0 Gets a description of the user-defined types defined in a particular schema.
`java.lang.String` | `getURL()` What's the url for this database?
`java.lang.String` | `getUserName()` What's our user name as known to the database?
`java.sql.ResultSet` | `getVersionColumns(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Gets a description of a table's columns that are automatically updated when any value in a row is updated.
`boolean` | `insertsAreDetected(int type)` JDBC 2.0 Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
`boolean` | `isCatalogAtStart()` Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
`boolean` | `isReadOnly()` Is the database in read-only mode?
`boolean` | `nullPlusNonNullIsNull()` Are concatenations between NULL and non-NULL values NULL? A JDBC CompliantTM driver always returns true.
`boolean` | `nullsAreSortedAtEnd()` Are NULL values sorted at the end regardless of sort order?
`boolean` | `nullsAreSortedAtStart()` Are NULL values sorted at the start regardless of sort order?
`boolean` | `nullsAreSortedHigh()` Are NULL values sorted high?
`boolean` | `nullsAreSortedLow()` Are NULL values sorted low?
`boolean` | `othersDeletesAreVisible(int type)` JDBC 2.0 Indicates whether deletes made by others are visible.
`boolean` | `othersInsertsAreVisible(int type)` JDBC 2.0 Indicates whether inserts made by others are visible.
`boolean` | `othersUpdatesAreVisible(int type)` JDBC 2.0 Indicates whether updates made by others are visible.
`boolean` | `ownDeletesAreVisible(int type)` JDBC 2.0 Indicates whether a result set's own deletes are visible.
`boolean` | `ownInsertsAreVisible(int type)` JDBC 2.0 Indicates whether a result set's own inserts are visible.
`boolean` | `ownUpdatesAreVisible(int type)` JDBC 2.0 Indicates whether a result set's own updates are visible.
`boolean` | `storesLowerCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
`boolean` | `storesLowerCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
`boolean` | `storesMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` | `storesMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` | `storesUpperCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
`boolean` | `storesUpperCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
`boolean` | `supportsAlterTableWithAddColumn()` Is "ALTER TABLE" with add column supported?
`boolean` | `supportsAlterTableWithDropColumn()` Is "ALTER TABLE" with drop column supported?
`boolean` | `supportsANSI92EntryLevelSQL()` Is the ANSI92 entry level SQL grammar supported? All JDBC CompliantTM drivers must return true.
`boolean` | `supportsANSI92FullSQL()` Is the ANSI92 full SQL grammar supported?
`boolean` | `supportsANSI92IntermediateSQL()` Is the ANSI92 intermediate SQL grammar supported?
`boolean` | `supportsBatchUpdates()` JDBC 2.0 Indicates whether the driver supports batch updates.
`boolean` | `supportsCatalogsInDataManipulation()` Can a catalog name be used in a data manipulation statement?
`boolean` | `supportsCatalogsInIndexDefinitions()` Can a catalog name be used in an index definition statement?
`boolean` | `supportsCatalogsInPrivilegeDefinitions()` Can a catalog name be used in a privilege definition statement?
`boolean` | `supportsCatalogsInProcedureCalls()` Can a catalog name be used in a procedure call statement?
`boolean` | `supportsCatalogsInTableDefinitions()` Can a catalog name be used in a table definition statement?
`boolean` | `supportsColumnAliasing()` Is column aliasing supported?
`boolean` | `supportsConvert()` Is the CONVERT function between SQL types supported?
`boolean` | `supportsConvert(int fromType, int toType)` Is CONVERT between the given SQL types supported?
`boolean` | `supportsCoreSQLGrammar()` Is the ODBC Core SQL grammar supported?
`boolean` | `supportsCorrelatedSubqueries()` Are correlated subqueries supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsDataDefinitionAndDataManipulationTransactions()` Are both data definition and data manipulation statements within a transaction supported?
`boolean` | `supportsDataManipulationTransactionsOnly()` Are only data manipulation statements within a transaction supported?
`boolean` | `supportsDifferentTableCorrelationNames()` If table correlation names are supported, are they restricted to be different from the names of the tables?
`boolean` | `supportsExpressionsInOrderBy()` Are expressions in "ORDER BY" lists supported?
`boolean` | `supportsExtendedSQLGrammar()` Is the ODBC Extended SQL grammar supported?
`boolean` | `supportsFullOuterJoins()` Are full nested outer joins supported?
`boolean` | `supportsGroupBy()` Is some form of "GROUP BY" clause supported?
`boolean` | `supportsGroupByBeyondSelect()` Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
`boolean` | `supportsGroupByUnrelated()` Can a "GROUP BY" clause use columns not in the SELECT?
`boolean` | `supportsIntegrityEnhancementFacility()` Is the SQL Integrity Enhancement Facility supported?
`boolean` | `supportsLikeEscapeClause()` Is the escape character in "LIKE" clauses supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsLimitedOuterJoins()` Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
`boolean` | `supportsMinimumSQLGrammar()` Is the ODBC Minimum SQL grammar supported? All JDBC CompliantTM drivers must return true.
`boolean` | `supportsMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return false.
`boolean` | `supportsMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return true.
`boolean` | `supportsMultipleResultSets()` Are multiple ResultSets from a single execute supported?
`boolean` | `supportsMultipleTransactions()` Can we have multiple transactions open at once (on different connections)?
`boolean` | `supportsNonNullableColumns()` Can columns be defined as non-nullable? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsOpenCursorsAcrossCommit()` Can cursors remain open across commits?
`boolean` | `supportsOpenCursorsAcrossRollback()` Can cursors remain open across rollbacks?
`boolean` | `supportsOpenStatementsAcrossCommit()` Can statements remain open across commits?
`boolean` | `supportsOpenStatementsAcrossRollback()` Can statements remain open across rollbacks?
`boolean` | `supportsOrderByUnrelated()` Can an "ORDER BY" clause use columns not in the SELECT statement?
`boolean` | `supportsOuterJoins()` Is some form of outer join supported?
`boolean` | `supportsPositionedDelete()` Is positioned DELETE supported?
`boolean` | `supportsPositionedUpdate()` Is positioned UPDATE supported?
`boolean` | `supportsResultSetConcurrency(int type, int conc)` JDBC 2.0 Does the database support the concurrency type in combination with the given result set type?
`boolean` | `supportsResultSetType(int type)` JDBC 2.0 Does the database support the given result set type?
`boolean` | `supportsSchemasInDataManipulation()` Can a schema name be used in a data manipulation statement?
`boolean` | `supportsSchemasInIndexDefinitions()` Can a schema name be used in an index definition statement?
`boolean` | `supportsSchemasInPrivilegeDefinitions()` Can a schema name be used in a privilege definition statement?
`boolean` | `supportsSchemasInProcedureCalls()` Can a schema name be used in a procedure call statement?
`boolean` | `supportsSchemasInTableDefinitions()` Can a schema name be used in a table definition statement?
`boolean` | `supportsSelectForUpdate()` Is SELECT for UPDATE supported?
`boolean` | `supportsStoredProcedures()` Are stored procedure calls using the stored procedure escape syntax supported?
`boolean` | `supportsSubqueriesInComparisons()` Are subqueries in comparison expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsSubqueriesInExists()` Are subqueries in 'exists' expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsSubqueriesInIns()` Are subqueries in 'in' statements supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsSubqueriesInQuantifieds()` Are subqueries in quantified expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsTableCorrelationNames()` Are table correlation names supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsTransactionIsolationLevel(int level)` Does this database support the given transaction isolation level?
`boolean` | `supportsTransactions()` Are transactions supported? If not, invoking the method `commit` is a noop and the isolation level is TRANSACTION_NONE.
`boolean` | `supportsUnion()` Is SQL UNION supported?
`boolean` | `supportsUnionAll()` Is SQL UNION ALL supported?
`boolean` | `updatesAreDetected(int type)` JDBC 2.0 Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
`boolean` | `usesLocalFilePerTable()` Does the database use a file for each table?
`boolean` | `usesLocalFiles()` Does the database store tables in a local file?

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### jdbcDatabaseMetaData

    jdbcDatabaseMetaData(jdbcConnection c)

  Constructor declaration
  Parameters:
    `c` -

Method Detail

### allProceduresAreCallable

    public boolean allProceduresAreCallable()

  Can all the procedures returned by getProcedures be called by the current user?
  Specified by:
    allProceduresAreCallable in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### allTablesAreSelectable

    public boolean allTablesAreSelectable()

  Can all the tables returned by getTable be SELECTed by the current user?
  Specified by:
    allTablesAreSelectable in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### getURL

    public java.lang.String getURL()

  What's the url for this database?
  Specified by:
    getURL in interface java.sql.DatabaseMetaData
  Returns:
    the url

### getUserName

    public java.lang.String getUserName()
                                 throws java.sql.SQLException

  What's our user name as known to the database?
  Specified by:
    getUserName in interface java.sql.DatabaseMetaData
  Returns:
    our database user name
  Throws:
    java.sql.SQLException - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws java.sql.SQLException

  Is the database in read-only mode?
  Specified by:
    isReadOnly in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise
  Throws:
    java.sql.SQLException - if a database access error occurs

### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()

  Are NULL values sorted high?
  Specified by:
    nullsAreSortedHigh in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### nullsAreSortedLow

    public boolean nullsAreSortedLow()

  Are NULL values sorted low?
  Specified by:
    nullsAreSortedLow in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()

  Are NULL values sorted at the start regardless of sort order?
  Specified by:
    nullsAreSortedAtStart in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()

  Are NULL values sorted at the end regardless of sort order?
  Specified by:
    nullsAreSortedAtEnd in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### getDatabaseProductName

    public java.lang.String getDatabaseProductName()

  What's the name of this database product?
  Specified by:
    getDatabaseProductName in interface java.sql.DatabaseMetaData
  Returns:
    database product name

### getDatabaseProductVersion

    public java.lang.String getDatabaseProductVersion()

  What's the version of this database product?
  Specified by:
    getDatabaseProductVersion in interface java.sql.DatabaseMetaData
  Returns:
    database version

### getDriverName

    public java.lang.String getDriverName()

  What's the name of this JDBC driver?
  Specified by:
    getDriverName in interface java.sql.DatabaseMetaData
  Returns:
    JDBC driver name

### getDriverVersion

    public java.lang.String getDriverVersion()

  What's the version of this JDBC driver?
  Specified by:
    getDriverVersion in interface java.sql.DatabaseMetaData
  Returns:
    JDBC driver version

### getDriverMajorVersion

    public int getDriverMajorVersion()

  What's this JDBC driver's major version number?
  Specified by:
    getDriverMajorVersion in interface java.sql.DatabaseMetaData
  Returns:
    JDBC driver major version

### getDriverMinorVersion

    public int getDriverMinorVersion()

  What's this JDBC driver's minor version number?
  Specified by:
    getDriverMinorVersion in interface java.sql.DatabaseMetaData
  Returns:
    JDBC driver minor version number

### usesLocalFiles

    public boolean usesLocalFiles()

  Does the database store tables in a local file?
  Specified by:
    usesLocalFiles in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()

  Does the database use a file for each table?
  Specified by:
    usesLocalFilePerTable in interface java.sql.DatabaseMetaData
  Returns:
    true if the database uses a local file for each table

### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()

  Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return false.
  Specified by:
    supportsMixedCaseIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
  Specified by:
    storesUpperCaseIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
  Specified by:
    storesLowerCaseIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
  Specified by:
    storesMixedCaseIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()

  Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return true.
  Specified by:
    supportsMixedCaseQuotedIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
  Specified by:
    storesUpperCaseQuotedIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
  Specified by:
    storesLowerCaseQuotedIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
  Specified by:
    storesMixedCaseQuotedIdentifiers in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### getIdentifierQuoteString

    public java.lang.String getIdentifierQuoteString()

  What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported. A JDBC CompliantTM driver always uses a double quote character.
  Specified by:
    getIdentifierQuoteString in interface java.sql.DatabaseMetaData
  Returns:
    the quoting string

### getSQLKeywords

    public java.lang.String getSQLKeywords()

  Gets a comma-separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
  Specified by:
    getSQLKeywords in interface java.sql.DatabaseMetaData
  Returns:
    the list

### getNumericFunctions

    public java.lang.String getNumericFunctions()

  Gets a comma-separated list of math functions. These are the X/Open CLI math function names used in the JDBC function escape clause.
  Specified by:
    getNumericFunctions in interface java.sql.DatabaseMetaData
  Returns:
    the list

### getStringFunctions

    public java.lang.String getStringFunctions()

  Gets a comma-separated list of string functions. These are the X/Open CLI string function names used in the JDBC function escape clause.
  Specified by:
    getStringFunctions in interface java.sql.DatabaseMetaData
  Returns:
    the list

### getSystemFunctions

    public java.lang.String getSystemFunctions()

  Gets a comma-separated list of system functions. These are the X/Open CLI system function names used in the JDBC function escape clause.
  Specified by:
    getSystemFunctions in interface java.sql.DatabaseMetaData
  Returns:
    the list

### getTimeDateFunctions

    public java.lang.String getTimeDateFunctions()

  Gets a comma-separated list of time and date functions.
  Specified by:
    getTimeDateFunctions in interface java.sql.DatabaseMetaData
  Returns:
    the list

### getSearchStringEscape

    public java.lang.String getSearchStringEscape()

  Gets the string that can be used to escape wildcard characters. This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

  The '_' character represents any single character.

  The '%' character represents any sequence of zero or more characters.

  Specified by:
    getSearchStringEscape in interface java.sql.DatabaseMetaData
  Returns:
    the string used to escape wildcard characters

### getExtraNameCharacters

    public java.lang.String getExtraNameCharacters()

  Gets all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
  Specified by:
    getExtraNameCharacters in interface java.sql.DatabaseMetaData
  Returns:
    the string containing the extra characters

### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()

  Is "ALTER TABLE" with add column supported?
  Specified by:
    supportsAlterTableWithAddColumn in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()

  Is "ALTER TABLE" with drop column supported?
  Specified by:
    supportsAlterTableWithDropColumn in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsColumnAliasing

    public boolean supportsColumnAliasing()

  Is column aliasing supported?

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC CompliantTM driver always returns true.

  Specified by:
    supportsColumnAliasing in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()

  Are concatenations between NULL and non-NULL values NULL? A JDBC CompliantTM driver always returns true.
  Specified by:
    nullPlusNonNullIsNull in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsConvert

    public boolean supportsConvert()

  Is the CONVERT function between SQL types supported?
  Specified by:
    supportsConvert in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)

  Is CONVERT between the given SQL types supported?

  In HSQL Database Engine, conversions are made over Strings, so everything theoretically is possible.

  Specified by:
    supportsConvert in interface java.sql.DatabaseMetaData
  Parameters:
    `fromType` - the type to convert from
    `toType` - the type to convert to
  Returns:
    `true` if so; `false` otherwise

### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()

  Are table correlation names supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsTableCorrelationNames in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()

  If table correlation names are supported, are they restricted to be different from the names of the tables?
  Specified by:
    supportsDifferentTableCorrelationNames in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()

  Are expressions in "ORDER BY" lists supported?
  Specified by:
    supportsExpressionsInOrderBy in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()

  Can an "ORDER BY" clause use columns not in the SELECT statement?
  Specified by:
    supportsOrderByUnrelated in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsGroupBy

    public boolean supportsGroupBy()

  Is some form of "GROUP BY" clause supported?
  Specified by:
    supportsGroupBy in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()

  Can a "GROUP BY" clause use columns not in the SELECT?
  Specified by:
    supportsGroupByUnrelated in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()

  Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
  Specified by:
    supportsGroupByBeyondSelect in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()

  Is the escape character in "LIKE" clauses supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsLikeEscapeClause in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()

  Are multiple ResultSets from a single execute supported?
  Specified by:
    supportsMultipleResultSets in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()

  Can we have multiple transactions open at once (on different connections)?
  Specified by:
    supportsMultipleTransactions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()

  Can columns be defined as non-nullable? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsNonNullableColumns in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()

  Is the ODBC Minimum SQL grammar supported? All JDBC CompliantTM drivers must return true.
  Specified by:
    supportsMinimumSQLGrammar in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()

  Is the ODBC Core SQL grammar supported?
  Specified by:
    supportsCoreSQLGrammar in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()

  Is the ODBC Extended SQL grammar supported?
  Specified by:
    supportsExtendedSQLGrammar in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()

  Is the ANSI92 entry level SQL grammar supported? All JDBC CompliantTM drivers must return true.
  Specified by:
    supportsANSI92EntryLevelSQL in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()

  Is the ANSI92 intermediate SQL grammar supported?
  Specified by:
    supportsANSI92IntermediateSQL in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()

  Is the ANSI92 full SQL grammar supported?
  Specified by:
    supportsANSI92FullSQL in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()

  Is the SQL Integrity Enhancement Facility supported?
  Specified by:
    supportsIntegrityEnhancementFacility in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsOuterJoins

    public boolean supportsOuterJoins()

  Is some form of outer join supported?
  Specified by:
    supportsOuterJoins in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()

  Are full nested outer joins supported?
  Specified by:
    supportsFullOuterJoins in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()

  Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
  Specified by:
    supportsLimitedOuterJoins in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### getSchemaTerm

    public java.lang.String getSchemaTerm()

  What's the database vendor's preferred term for "schema"?
  Specified by:
    getSchemaTerm in interface java.sql.DatabaseMetaData
  Returns:
    the vendor term

### getProcedureTerm

    public java.lang.String getProcedureTerm()

  What's the database vendor's preferred term for "procedure"?
  Specified by:
    getProcedureTerm in interface java.sql.DatabaseMetaData
  Returns:
    the vendor term

### getCatalogTerm

    public java.lang.String getCatalogTerm()

  What's the database vendor's preferred term for "catalog"?
  Specified by:
    getCatalogTerm in interface java.sql.DatabaseMetaData
  Returns:
    the vendor term

### isCatalogAtStart

    public boolean isCatalogAtStart()

  Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
  Specified by:
    isCatalogAtStart in interface java.sql.DatabaseMetaData
  Returns:
    true if it appears at the start

### getCatalogSeparator

    public java.lang.String getCatalogSeparator()

  What's the separator between catalog and table name?
  Specified by:
    getCatalogSeparator in interface java.sql.DatabaseMetaData
  Returns:
    the separator string

### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()

  Can a schema name be used in a data manipulation statement?
  Specified by:
    supportsSchemasInDataManipulation in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()

  Can a schema name be used in a procedure call statement?
  Specified by:
    supportsSchemasInProcedureCalls in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()

  Can a schema name be used in a table definition statement?
  Specified by:
    supportsSchemasInTableDefinitions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()

  Can a schema name be used in an index definition statement?
  Specified by:
    supportsSchemasInIndexDefinitions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()

  Can a schema name be used in a privilege definition statement?
  Specified by:
    supportsSchemasInPrivilegeDefinitions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()

  Can a catalog name be used in a data manipulation statement?
  Specified by:
    supportsCatalogsInDataManipulation in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()

  Can a catalog name be used in a procedure call statement?
  Specified by:
    supportsCatalogsInProcedureCalls in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()

  Can a catalog name be used in a table definition statement?
  Specified by:
    supportsCatalogsInTableDefinitions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()

  Can a catalog name be used in an index definition statement?
  Specified by:
    supportsCatalogsInIndexDefinitions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()

  Can a catalog name be used in a privilege definition statement?
  Specified by:
    supportsCatalogsInPrivilegeDefinitions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsPositionedDelete

    public boolean supportsPositionedDelete()

  Is positioned DELETE supported?
  Specified by:
    supportsPositionedDelete in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()

  Is positioned UPDATE supported?
  Specified by:
    supportsPositionedUpdate in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()

  Is SELECT for UPDATE supported?
  Specified by:
    supportsSelectForUpdate in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsStoredProcedures

    public boolean supportsStoredProcedures()

  Are stored procedure calls using the stored procedure escape syntax supported?
  Specified by:
    supportsStoredProcedures in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()

  Are subqueries in comparison expressions supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsSubqueriesInComparisons in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()

  Are subqueries in 'exists' expressions supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsSubqueriesInExists in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()

  Are subqueries in 'in' statements supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsSubqueriesInIns in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()

  Are subqueries in quantified expressions supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsSubqueriesInQuantifieds in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()

  Are correlated subqueries supported? A JDBC CompliantTM driver always returns true.
  Specified by:
    supportsCorrelatedSubqueries in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsUnion

    public boolean supportsUnion()

  Is SQL UNION supported?
  Specified by:
    supportsUnion in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsUnionAll

    public boolean supportsUnionAll()

  Is SQL UNION ALL supported?
  Specified by:
    supportsUnionAll in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()

  Can cursors remain open across commits?
  Specified by:
    supportsOpenCursorsAcrossCommit in interface java.sql.DatabaseMetaData
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open

### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()

  Can cursors remain open across rollbacks?
  Specified by:
    supportsOpenCursorsAcrossRollback in interface java.sql.DatabaseMetaData
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open

### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()

  Can statements remain open across commits?
  Specified by:
    supportsOpenStatementsAcrossCommit in interface java.sql.DatabaseMetaData
  Returns:
    `true` if statements always remain open; `false` if they might not remain open

### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()

  Can statements remain open across rollbacks?
  Specified by:
    supportsOpenStatementsAcrossRollback in interface java.sql.DatabaseMetaData
  Returns:
    `true` if statements always remain open; `false` if they might not remain open

### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()

  How many hex characters can you have in an inline binary literal?
  Specified by:
    getMaxBinaryLiteralLength in interface java.sql.DatabaseMetaData
  Returns:
    max binary literal length in hex characters; a result of zero means that there is no limit or the limit is not known

### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()

  What's the max length for a character literal?
  Specified by:
    getMaxCharLiteralLength in interface java.sql.DatabaseMetaData
  Returns:
    max literal length; a result of zero means that there is no limit or the limit is not known

### getMaxColumnNameLength

    public int getMaxColumnNameLength()

  What's the limit on column name length?
  Specified by:
    getMaxColumnNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max column name length; a result of zero means that there is no limit or the limit is not known

### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()

  What's the maximum number of columns in a "GROUP BY" clause?
  Specified by:
    getMaxColumnsInGroupBy in interface java.sql.DatabaseMetaData
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known

### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()

  What's the maximum number of columns allowed in an index?
  Specified by:
    getMaxColumnsInIndex in interface java.sql.DatabaseMetaData
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known

### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()

  What's the maximum number of columns in an "ORDER BY" clause?
  Specified by:
    getMaxColumnsInOrderBy in interface java.sql.DatabaseMetaData
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known

### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()

  What's the maximum number of columns in a "SELECT" list?
  Specified by:
    getMaxColumnsInSelect in interface java.sql.DatabaseMetaData
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known

### getMaxColumnsInTable

    public int getMaxColumnsInTable()

  What's the maximum number of columns in a table?
  Specified by:
    getMaxColumnsInTable in interface java.sql.DatabaseMetaData
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known

### getMaxConnections

    public int getMaxConnections()

  How many active connections can we have at a time to this database?
  Specified by:
    getMaxConnections in interface java.sql.DatabaseMetaData
  Returns:
    max number of active connections; a result of zero means that there is no limit or the limit is not known

### getMaxCursorNameLength

    public int getMaxCursorNameLength()

  What's the maximum cursor name length?
  Specified by:
    getMaxCursorNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max cursor name length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxIndexLength

    public int getMaxIndexLength()

  What's the maximum length of an index (in bytes)?
  Specified by:
    getMaxIndexLength in interface java.sql.DatabaseMetaData
  Returns:
    max index length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()

  What's the maximum length allowed for a schema name?
  Specified by:
    getMaxSchemaNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()

  What's the maximum length of a procedure name?
  Specified by:
    getMaxProcedureNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()

  What's the maximum length of a catalog name?
  Specified by:
    getMaxCatalogNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxRowSize

    public int getMaxRowSize()

  What's the maximum length of a single row?
  Specified by:
    getMaxRowSize in interface java.sql.DatabaseMetaData
  Returns:
    max row size in bytes; a result of zero means that there is no limit or the limit is not known

### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()

  Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
  Specified by:
    doesMaxRowSizeIncludeBlobs in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### getMaxStatementLength

    public int getMaxStatementLength()

  What's the maximum length of a SQL statement?
  Specified by:
    getMaxStatementLength in interface java.sql.DatabaseMetaData
  Returns:
    max length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxStatements

    public int getMaxStatements()

  How many active statements can we have open at one time to this database?
  Specified by:
    getMaxStatements in interface java.sql.DatabaseMetaData
  Returns:
    the maximum number of statements that can be open at one time; a result of zero means that there is no limit or the limit is not known

### getMaxTableNameLength

    public int getMaxTableNameLength()

  What's the maximum length of a table name?
  Specified by:
    getMaxTableNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known

### getMaxTablesInSelect

    public int getMaxTablesInSelect()

  What's the maximum number of tables in a SELECT statement?
  Specified by:
    getMaxTablesInSelect in interface java.sql.DatabaseMetaData
  Returns:
    the maximum number of tables allowed in a SELECT statement; a result of zero means that there is no limit or the limit is not known

### getMaxUserNameLength

    public int getMaxUserNameLength()

  What's the maximum length of a user name?
  Specified by:
    getMaxUserNameLength in interface java.sql.DatabaseMetaData
  Returns:
    max user name length in bytes; a result of zero means that there is no limit or the limit is not known

### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()

  What's the database's default transaction isolation level? The values are defined in `java.sql.Connection`.
  Specified by:
    getDefaultTransactionIsolation in interface java.sql.DatabaseMetaData
  Returns:
    the default isolation level
  See Also:
    `Connection`

### supportsTransactions

    public boolean supportsTransactions()

  Are transactions supported? If not, invoking the method `commit` is a noop and the isolation level is TRANSACTION_NONE.
  Specified by:
    supportsTransactions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if transactions are supported; `false` otherwise

### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)

  Does this database support the given transaction isolation level?
  Specified by:
    supportsTransactionIsolationLevel in interface java.sql.DatabaseMetaData
  Parameters:
    `level` - the values are defined in `java.sql.Connection`
  Returns:
    `true` if so; `false` otherwise
  See Also:
    `Connection`

### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()

  Are both data definition and data manipulation statements within a transaction supported?
  Specified by:
    supportsDataDefinitionAndDataManipulationTransactions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()

  Are only data manipulation statements within a transaction supported?
  Specified by:
    supportsDataManipulationTransactionsOnly in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()

  Does a data definition statement within a transaction force the transaction to commit?
  Specified by:
    dataDefinitionCausesTransactionCommit in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()

  Is a data definition statement within a transaction ignored?
  Specified by:
    dataDefinitionIgnoredInTransactions in interface java.sql.DatabaseMetaData
  Returns:
    `true` if so; `false` otherwise

### getProcedures

    public java.sql.ResultSet getProcedures(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String procedureNamePattern)
                                     throws java.sql.SQLException

  Gets a description of the stored procedures available in a catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. reserved for future use
  5. reserved for future use
  6. reserved for future use
  7. REMARKS String => explanatory comment on the procedure
  8. PROCEDURE_TYPE short => kind of procedure:
     - procedureResultUnknown - May return a result
     - procedureNoResult - Does not return a result
     - procedureReturnsResult - Returns a result
  Specified by:
    getProcedures in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
  Returns:
    ResultSet - each row is a procedure description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getProcedureColumns

    public java.sql.ResultSet getProcedureColumns(java.lang.String catalog,
                                                  java.lang.String schemaPattern,
                                                  java.lang.String procedureNamePattern,
                                                  java.lang.String columnNamePattern)
                                           throws java.sql.SQLException

  Gets a description of a catalog's stored procedure parameters and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the ResultSet is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in ResultSet
  6. DATA_TYPE short => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL?
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String => comment describing parameter/column

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database.

  Specified by:
    getProcedureColumns in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    ResultSet - each row describes a stored procedure parameter or column
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTables

    public java.sql.ResultSet getTables(java.lang.String catalog,
                                        java.lang.String schemaPattern,
                                        java.lang.String tableNamePattern,
                                        java.lang.String[] types)
                                 throws java.sql.SQLException

  Gets a description of tables available in a catalog.

  Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

  Each table description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String => explanatory comment on the table

  Note: Some databases may not return information for all tables.

  Specified by:
    getTables in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `types` - a list of table types to include; null returns all types
  Returns:
    ResultSet - each row is a table description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getSchemas

    public java.sql.ResultSet getSchemas()
                                  throws java.sql.SQLException

  Gets the schema names available in this database. The results are ordered by schema name.

  The schema column is:

  1. TABLE_SCHEM String => schema name
  Specified by:
    getSchemas in interface java.sql.DatabaseMetaData
  Returns:
    ResultSet - each row has a single String column that is a schema name
  Throws:
    java.sql.SQLException - if a database access error occurs

### getCatalogs

    public java.sql.ResultSet getCatalogs()
                                   throws java.sql.SQLException

  Gets the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String => catalog name
  Specified by:
    getCatalogs in interface java.sql.DatabaseMetaData
  Returns:
    ResultSet - each row has a single String column that is a catalog name
  Throws:
    java.sql.SQLException - if a database access error occurs

### getTableTypes

    public java.sql.ResultSet getTableTypes()
                                     throws java.sql.SQLException

  Gets the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  Specified by:
    getTableTypes in interface java.sql.DatabaseMetaData
  Returns:
    ResultSet - each row has a single String column that is a table type
  Throws:
    java.sql.SQLException - if a database access error occurs

### getColumns

    public java.sql.ResultSet getColumns(java.lang.String catalog,
                                         java.lang.String schemaPattern,
                                         java.lang.String tableNamePattern,
                                         java.lang.String columnNamePattern)
                                  throws java.sql.SQLException

  Gets a description of table columns available in the specified catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE short => SQL type from java.sql.Types
  6. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int => the number of fractional digits
  10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  11. NULLABLE int => is NULL allowed?
      - columnNoNulls - might not allow NULL values
      - columnNullable - definitely allows NULL values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String => comment describing column (may be null)
  13. COLUMN_DEF String => default value (may be null)
  14. SQL_DATA_TYPE int => unused
  15. SQL_DATETIME_SUB int => unused
  16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  17. ORDINAL_POSITION int => index of column in table (starting at 1)
  18. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.
  Specified by:
    getColumns in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    ResultSet - each row is a column description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getColumnPrivileges

    public java.sql.ResultSet getColumnPrivileges(java.lang.String catalog,
                                                  java.lang.String schema,
                                                  java.lang.String tableP,
                                                  java.lang.String columnNamePattern)
                                           throws java.sql.SQLException

  Gets a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. GRANTOR => grantor of access (may be null)
  6. GRANTEE String => grantee of access
  7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown
  Specified by:
    getColumnPrivileges in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `columnNamePattern` - a column name pattern
  Returns:
    ResultSet - each row is a column privilege description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTablePrivileges

    public java.sql.ResultSet getTablePrivileges(java.lang.String catalog,
                                                 java.lang.String schemaPattern,
                                                 java.lang.String tableNamePattern)
                                          throws java.sql.SQLException

  Gets a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this priviledge applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. GRANTOR => grantor of access (may be null)
  5. GRANTEE String => grantee of access
  6. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown
  Specified by:
    getTablePrivileges in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
  Returns:
    ResultSet - each row is a table privilege description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getBestRowIdentifier

    public java.sql.ResultSet getBestRowIdentifier(java.lang.String catalog,
                                                   java.lang.String schema,
                                                   java.lang.String table,
                                                   int scope,
                                                   boolean nullable)
                                            throws java.sql.SQLException

  Gets a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short => actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => not used
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column
  Specified by:
    getBestRowIdentifier in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `scope` - the scope of interest; use same values as SCOPE
    `nullable` - include columns that are nullable?
  Returns:
    ResultSet - each row is a column description
  Throws:
    java.sql.SQLException - if a database access error occurs

### getVersionColumns

    public java.sql.ResultSet getVersionColumns(java.lang.String catalog,
                                                java.lang.String schema,
                                                java.lang.String table)
                                         throws java.sql.SQLException

  Gets a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short => is not used
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => length of column value in bytes
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column
  Specified by:
    getVersionColumns in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a column description
  Throws:
    java.sql.SQLException - if a database access error occurs

### getPrimaryKeys

    public java.sql.ResultSet getPrimaryKeys(java.lang.String catalog,
                                             java.lang.String schema,
                                             java.lang.String tableP)
                                      throws java.sql.SQLException

  Gets a description of a table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. KEY_SEQ short => sequence number within primary key
  6. PK_NAME String => primary key name (may be null)
  Specified by:
    getPrimaryKeys in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a primary key column description
  Throws:
    java.sql.SQLException - if a database access error occurs

### getImportedKeys

    public java.sql.ResultSet getImportedKeys(java.lang.String catalog,
                                              java.lang.String schema,
                                              java.lang.String table)
                                       throws java.sql.SQLException

  Gets a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog being imported (may be null)
  2. PKTABLE_SCHEM String => primary key table schema being imported (may be null)
  3. PKTABLE_NAME String => primary key table name being imported
  4. PKCOLUMN_NAME String => primary key column name being imported
  5. FKTABLE_CAT String => foreign key table catalog (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null)
  7. FKTABLE_NAME String => foreign key table name
  8. FKCOLUMN_NAME String => foreign key column name
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition
  Specified by:
    getImportedKeys in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a primary key column description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getExportedKeys

    public java.sql.ResultSet getExportedKeys(java.lang.String catalog,
                                              java.lang.String schema,
                                              java.lang.String table)
                                       throws java.sql.SQLException

  Gets a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition
  Specified by:
    getExportedKeys in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a foreign key column description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getCrossReference

    public java.sql.ResultSet getCrossReference(java.lang.String primaryCatalog,
                                                java.lang.String primarySchema,
                                                java.lang.String primaryTable,
                                                java.lang.String foreignCatalog,
                                                java.lang.String foreignSchema,
                                                java.lang.String foreignTable)
                                         throws java.sql.SQLException

  Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition
  Specified by:
    getCrossReference in interface java.sql.DatabaseMetaData
  Parameters:
    `primaryCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `primarySchema` - a schema name; "" retrieves those without a schema
    `primaryTable` - the table name that exports the key
    `foreignCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `foreignSchema` - a schema name; "" retrieves those without a schema
    `foreignTable` - the table name that imports the key
  Returns:
    ResultSet - each row is a foreign key column description
  Throws:
    java.sql.SQLException - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getTypeInfo

    public java.sql.ResultSet getTypeInfo()
                                   throws java.sql.SQLException

  Gets a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  Each type description has the following columns:

  1. TYPE_NAME String => Type name
  2. DATA_TYPE short => SQL data type from java.sql.Types
  3. PRECISION int => maximum precision
  4. LITERAL_PREFIX String => prefix used to quote a literal (may be null)
  5. LITERAL_SUFFIX String => suffix used to quote a literal (may be null)
  6. CREATE_PARAMS String => parameters used in creating the type (may be null)
  7. NULLABLE short => can you use NULL for this type?
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=> is it case sensitive?
  9. SEARCHABLE short => can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean => is it unsigned?
  11. FIXED_PREC_SCALE boolean => can it be a money value?
  12. AUTO_INCREMENT boolean => can it be used for an auto-increment value?
  13. LOCAL_TYPE_NAME String => localized version of type name (may be null)
  14. MINIMUM_SCALE short => minimum scale supported
  15. MAXIMUM_SCALE short => maximum scale supported
  16. SQL_DATA_TYPE int => unused
  17. SQL_DATETIME_SUB int => unused
  18. NUM_PREC_RADIX int => usually 2 or 10
  Specified by:
    getTypeInfo in interface java.sql.DatabaseMetaData
  Returns:
    ResultSet - each row is a SQL type description
  Throws:
    java.sql.SQLException - if a database access error occurs

### getIndexInfo

    public java.sql.ResultSet getIndexInfo(java.lang.String catalog,
                                           java.lang.String schema,
                                           java.lang.String tableP,
                                           boolean unique,
                                           boolean approximate)
                                    throws java.sql.SQLException

  Gets a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. NON_UNIQUE boolean => Can index values be non-unique? false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String => index catalog (may be null); null when TYPE is tableIndexStatistic
  6. INDEX_NAME String => index name; null when TYPE is tableIndexStatistic
  7. TYPE short => index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String => column name; null when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
  11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String => Filter condition, if any. (may be null)
  Specified by:
    getIndexInfo in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
    `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
  Returns:
    ResultSet - each row is an index column description
  Throws:
    java.sql.SQLException - if a database access error occurs

### supportsResultSetType

    public boolean supportsResultSetType(int type)

  JDBC 2.0 Does the database support the given result set type?
  Specified by:
    supportsResultSetType in interface java.sql.DatabaseMetaData
  Parameters:
    `type` - defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  See Also:
    `Connection`

### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int conc)

  JDBC 2.0 Does the database support the concurrency type in combination with the given result set type?
  Specified by:
    supportsResultSetConcurrency in interface java.sql.DatabaseMetaData
  Parameters:
    `type` - defined in `java.sql.ResultSet`
    `concurrency` - type defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  See Also:
    `Connection`

### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)

  JDBC 2.0 Indicates whether a result set's own updates are visible.
  Specified by:
    ownUpdatesAreVisible in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if updates are visible for the result set type; `false` otherwise

### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)

  JDBC 2.0 Indicates whether a result set's own deletes are visible.
  Specified by:
    ownDeletesAreVisible in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if deletes are visible for the result set type; `false` otherwise

### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)

  JDBC 2.0 Indicates whether a result set's own inserts are visible.
  Specified by:
    ownInsertsAreVisible in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if inserts are visible for the result set type; `false` otherwise

### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)

  JDBC 2.0 Indicates whether updates made by others are visible.
  Specified by:
    othersUpdatesAreVisible in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if updates made by others are visible for the result set type; `false` otherwise

### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)

  JDBC 2.0 Indicates whether deletes made by others are visible.
  Specified by:
    othersDeletesAreVisible in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if deletes made by others are visible for the result set type; `false` otherwise

### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)

  JDBC 2.0 Indicates whether inserts made by others are visible.
  Specified by:
    othersInsertsAreVisible in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if updates are visible for the result set type

### updatesAreDetected

    public boolean updatesAreDetected(int type)

  JDBC 2.0 Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
  Specified by:
    updatesAreDetected in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if changes are detected by the result set type; `false` otherwise

### deletesAreDetected

    public boolean deletesAreDetected(int type)

  JDBC 2.0 Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). If deletesAreDetected() returns false, then deleted rows are removed from the result set.
  Specified by:
    deletesAreDetected in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if changes are detected by the resultset type

### insertsAreDetected

    public boolean insertsAreDetected(int type)

  JDBC 2.0 Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
  Specified by:
    insertsAreDetected in interface java.sql.DatabaseMetaData
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if changes are detected by the resultset type

### supportsBatchUpdates

    public boolean supportsBatchUpdates()

  JDBC 2.0 Indicates whether the driver supports batch updates.
  Specified by:
    supportsBatchUpdates in interface java.sql.DatabaseMetaData
  Returns:
    true if the driver supports batch updates; false otherwise

### getUDTs

    public java.sql.ResultSet getUDTs(java.lang.String catalog,
                                      java.lang.String schemaPattern,
                                      java.lang.String typeNamePattern,
                                      int[] types)
                               throws java.sql.SQLException

  JDBC 2.0 Gets a description of the user-defined types defined in a particular schema. Schema-specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.

  Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

  Each type description has the following columns:

  1. TYPE_CAT String => the type's catalog (may be null)
  2. TYPE_SCHEM String => type's schema (may be null)
  3. TYPE_NAME String => type name
  4. CLASS_NAME String => Java class name
  5. DATA_TYPE String => type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
  6. REMARKS String => explanatory comment on the type

  Note: If the driver does not support UDTs, an empty result set is returned.

  Specified by:
    getUDTs in interface java.sql.DatabaseMetaData
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `typeNamePattern` - a type name pattern; may be a fully-qualified name
    `types` - a list of user-named types to include (JAVA_OBJECT, STRUCT, or DISTINCT); null returns all types
  Returns:
    ResultSet - each row is a type description
  Throws:
    java.sql.SQLException - if a database access error occurs

### getConnection

    public java.sql.Connection getConnection()

  JDBC 2.0 Retrieves the connection that produced this metadata object.
  Specified by:
    getConnection in interface java.sql.DatabaseMetaData
  Returns:
    the connection that produced this metadata object

Package | Class | Tree | Deprecated
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD